//
//  MHTitleView.m

//
//  Created by markhunte on 13/12/2010.
//  Copyright 2010 markosx.com. All rights reserved.
//

#import "MHTitleView.h"
#import <Carbon/Carbon.h>
@implementation MHTitleView
BOOL exitedOnce;  //-- The mouse may be in the tracking zone of the mouse entered at launch. This will insure that the Title does not set the alpha to 1.0 too early or the clear color will still leave the edge of the fram visable when alpha then goes to 0.0

- (id)initWithFrame:(NSRect)frameRect
{
    self = [super initWithFrame:frameRect];
    exitedOnce = false;
    return self;
}
- (void)mouseEntered:(NSEvent *)theEvent {
    [super mouseEntered:theEvent];
    
    if (exitedOnce) {
      [ self  setAlphaValue:1.0];
         exitedOnce = true;
    }
  
  /// NSLog(@" mouseEntered MHTV");
}

- (void)mouseExited:(NSEvent *)theEvent {
    [super mouseExited:theEvent];
  
  [ self setAlphaValue:0.0];
   /// NSLog(@"mouseExited MHTV");
     exitedOnce = true;
}

-(void)updateTrackingAreas{
    
    [super updateTrackingAreas];
    
    NSTrackingAreaOptions options =NSTrackingInVisibleRect| NSTrackingMouseEnteredAndExited |NSTrackingEnabledDuringMouseDrag |NSTrackingMouseMoved |NSTrackingActiveInKeyWindow;
    
    trackingArea = [[NSTrackingArea alloc] initWithRect:NSZeroRect options:options owner:self userInfo:nil];
    [self addTrackingArea:trackingArea];
    
}


-(void)showTitlebar{
    [self setAlphaValue:1.0];
}



- (void)drawRect:(NSRect)rect
{ 
	 [ self setAlphaValue:0.0];
	
		 [[NSColor blueColor] set];
		NSRectFill([self frame]);
    
    if (![self.identifier isEqualTo:@"window2TitleView"]) {
      [self performSelector:@selector(showTitlebar) withObject:nil afterDelay:0.5];
    }
   
 
	
}



@end
