//
//  MyWindow.m
//
//  Created by markhunte on 12/12/2010.
//  Copyright 2010 __markosx.com__. All rights reserved.
//

#import "MyWindow.h"

@implementation MyWindow

- (id)initWithContentRect:(NSRect)contentRect styleMask:(unsigned int)aStyle backing:(NSBackingStoreType)bufferingType defer:(BOOL)flag {
 
        self = [super initWithContentRect:contentRect styleMask:NSBorderlessWindowMask | NSClosableWindowMask backing:NSBackingStoreBuffered defer:NO];
        if (self)
        {
            
           
          // [self setCollectionBehavior:NSWindowCollectionBehaviorCanJoinAllSpaces ]; //this one works
            [self setOpaque:NO];
            [self setHasShadow:NO];
            //[self setLevel:NSMainMenuWindowLevel];
             [self setLevel:NSNormalWindowLevel];
            [self setDelegate:self];
            
            //---  NSLog(@"delegate %@",[self delegate]);
            
        }
        return self;

}


- (BOOL)canBecomeKeyWindow {
    return YES;
}


- (IBAction)performBorderlessClose:(id)sender {
    if([[self delegate] respondsToSelector:@selector(windowShouldClose:)]) {
        if(![[self delegate] windowShouldClose:self]) return;
    } else if([self respondsToSelector:@selector(windowShouldClose:)]) {
        if(![self windowShouldClose:self]) return;
    }
    [self close];
}


- (BOOL)validateMenuItem:(NSMenuItem *)menuItem
{
    return ([menuItem action] == @selector(performClose:) || [menuItem action] == @selector(performZoom:) || [menuItem action] == @selector(performMiniaturize:)) ? YES : [super validateMenuItem:menuItem];
}

/*


- (void)performClose:(id)sender
{
    if([[self delegate] respondsToSelector:@selector(windowShouldClose:)])
    {
        if(![[self delegate] windowShouldClose:self]) return;
    }
    else if([self respondsToSelector:@selector(windowShouldClose:)])
    {
        if(![self windowShouldClose:self]) return;
    }
    
    [self close];
}
*/
- (void)mouseDown:(NSEvent *)theEvent {
    // Get the mouse location in window coordinates.
    self.initialLocation = [theEvent locationInWindow];
    
  ////----->>> NSLog(@" %@theEvent",theEvent);
    
}
- (void)mouseDragged:(NSEvent *)theEvent {
    NSRect screenVisibleFrame = [[NSScreen mainScreen] visibleFrame];
    NSRect windowFrame = [self frame];
    NSPoint newOrigin = windowFrame.origin;
	
    // Get the mouse location in window coordinates.
    NSPoint currentLocation = [theEvent locationInWindow];
    // Update the origin with the difference between the new mouse location and the old mouse location.
    newOrigin.x += (currentLocation.x - _initialLocation.x);
    newOrigin.y += (currentLocation.y - _initialLocation.y);
	
    // Don't let window get dragged up under the menu bar
	//if ( ! [self styleMask] ==8  ) {//--== NSBorderlessWindowMask | NSResizableWindowMask
        
   
    if ((newOrigin.y + (windowFrame.size.height )) > (screenVisibleFrame.origin.y + screenVisibleFrame.size.height )) {
        newOrigin.y = screenVisibleFrame.origin.y + (screenVisibleFrame.size.height - (windowFrame.size.height ));
        /* NOTE: IF this window frame extends above the visable rect when using clearColor) for the windows view. when the window is drawn all is fine, but if you try and drag the window up towards the screens menu bar it will stop. before it should. So you have to minus -139 to the windowFrame.size.height for example   (newOrigin.y + (windowFrame.size.height -139)   to fool the - (void)mouseDragged:(NSEvent *)theEvent that the hieght.. of the window is smaller.*/ }
    
    // Move the window to the new location
    [self setFrameOrigin:newOrigin];
}
    
     //}

 

-(BOOL)windowShouldClose:(id)sender{
    
    NSLog(@" WINDOW CLOSE");
    return YES;
}

 

@end
