//
//  ViewController.m
//  JSMessageExample
//
//  Created by Joshua Kehn on 10/27/14.
//  Copyright (c) 2014 KEHN. All rights reserved.
//

#import "ViewControllerPrefs.h"



@implementation ViewControllerPrefs

-(void)awakeFromNib{
    
    
}




- (void)setUpPrefsWebView {
    // First create a WKWebViewConfiguration object so we can add a controller
    // pointing back to this ViewController.
    WKWebViewConfiguration *configuration = [[WKWebViewConfiguration alloc]
                                             init];
    WKUserContentController *controller = [[WKUserContentController alloc]
                                           init];
    
    // Add a script handler for the "observe" call. This is added to every frame
    // in the document (window.webkit.messageHandlers.NAME).
    [controller addScriptMessageHandler:self name:@"pageCalls"];
    configuration.userContentController = controller;
    
    // This is the URL to be loaded into the WKWebView.
    NSURL *jsbin = [[NSBundle mainBundle]URLForResource:@"controls"  withExtension:@"html"];
    
    
   
    // Initialize the WKWebView with the current frame and the configuration
    // setup above
    _webViewPrefs = [[WKWebView alloc] initWithFrame:self.view.bounds
                                  configuration:configuration];
    
    
    // Load the jsbin URL into the WKWebView and then add it as a sub-view.
    [_webViewPrefs loadRequest:[NSURLRequest requestWithURL:jsbin]];
    [self.PrefContainer addSubview:_webViewPrefs];
    
    _webViewPrefs.wantsLayer = YES;
    
    
    
    
    /*  SET WKWEBVIEW CONSTRAINTS TO FOLLOW WINDOW SIZE  */
    
    NSLayoutConstraint *  constraintTop = [NSLayoutConstraint constraintWithItem:_webViewPrefs  attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.PrefContainer attribute:NSLayoutAttributeTop multiplier:1.0f constant:1.f];
    
    
    NSLayoutConstraint *  constraintBottom = [NSLayoutConstraint constraintWithItem:_webViewPrefs attribute:NSLayoutAttributeBottom relatedBy:NSLayoutRelationEqual toItem:self.PrefContainer attribute:NSLayoutAttributeBottom multiplier:1.0f constant:0.f];
    
    NSLayoutConstraint *  constraintLeading= [NSLayoutConstraint constraintWithItem:_webViewPrefs attribute: NSLayoutAttributeLeading relatedBy:NSLayoutRelationEqual toItem:self.PrefContainer attribute:NSLayoutAttributeLeading multiplier:1.0f constant:0.f];
    
    NSLayoutConstraint *  constraintTrailing= [NSLayoutConstraint constraintWithItem:_webViewPrefs attribute: NSLayoutAttributeTrailing relatedBy:NSLayoutRelationEqual toItem:self.PrefContainer attribute:NSLayoutAttributeTrailing multiplier:1.0f constant:0.f];
    
    
    [self.PrefContainer addConstraint:constraintTrailing];
    
    [self.PrefContainer addConstraint:constraintLeading];
    [self.PrefContainer addConstraint:constraintTop];
    [self.PrefContainer addConstraint:constraintBottom];
    
    [_webViewPrefs  setTranslatesAutoresizingMaskIntoConstraints: NO];
    
}

        
- (void)viewDidLoad {
    [super viewDidLoad];
 
    [self setUpPrefsWebView];
  
}

//-- Direct call From  App Action to Webpage
- (IBAction)runTimeline:(id)sender {
    
    NSString *exec_template = @"window.myhypedocument.startTimelineNamed('timeline1');$('#headline').html(\"received: %@\");";
    NSString *theMessage = @"Call from App = Run Timeline";
    
    NSString *exec = [NSString stringWithFormat:exec_template, theMessage];
    //NSString *exec = [NSString stringWithFormat:exec_template, version];
    [_webViewPrefs evaluateJavaScript:exec completionHandler:nil];
    
    
   
}




//-- Calls From Webpage  to App

- (void)userContentController:(WKUserContentController *)userContentController
      didReceiveScriptMessage:(WKScriptMessage *)message {
 NSLog(@"Received event %@", message.body);
    // Check to make sure the name is correct
    if ([message.name isEqualToString:@"pageCalls"]) {
        
       
 //--Open app window
        if ([message.body isEqualToString:@"closePrefsButton"] ) {
            
            
            //--THe web button has its own action to play in reverse when closing.
            [_window_1 performSelector:@selector(  endSheet:  ) withObject:_prefControls afterDelay:1.5];
            
            
            NSString *exec_template2 = @"window.myhypedocument.continueTimelineNamed('prefsText');";
            [ViewController performSelector:@selector(  callFromOtherController:  ) withObject:exec_template2 afterDelay:0.5];
            return;
        }
        
        //--Open app window
        if ([message.body isEqualToString:@"OpenWin2"] ) {
            //[ _window_2 makeKeyAndOrderFront:self];
            
            [ _window2Drawer open:self];
            [self callBackToWebPage:message];
            return;
        }
     
    }
    

    
}

- (IBAction)openPrefsSheet:(id)sender {
 
    [_window_1 beginSheet:_prefControls completionHandler:^(NSModalResponse returnCode) {
        
    }];
    
    
    
    //-- Direct Call from APP to webplage
    NSString *exec_template = @"window.myhypedocument.continueTimelineNamed('buttons');";
   
    
   
    //NSString *exec = [NSString stringWithFormat:exec_template, version];
    [_webViewPrefs evaluateJavaScript:exec_template completionHandler:nil];
    
    NSString *exec_template2 = @"window.myhypedocument.continueTimelineNamed('prefsText');";

    [ViewController performSelector:@selector(  callFromOtherController:  ) withObject:exec_template2 afterDelay:0.5];
    
   
}

//--execute the javascript from the callback
- (void)callBackToWebPage:(WKScriptMessage *)message
{
    NSString *theMessage = message.body;
    
    // Execute some JavaScript using the result
    NSString *exec_template = @"$('#headline').html(\"received: %@\");";
    NSString *exec = [NSString stringWithFormat:exec_template, theMessage];
    [_webViewPrefs evaluateJavaScript:exec completionHandler:nil];
}


@end
